import java.util.Comparator;

public class TestPrioQueue {
 static class MyType {
  String name;
  int age;
  
  public MyType(String name, int age) {
   this.name = name;
   this.age = age;
  }
  public String toString() {
   return "{" + name + ", " + age + "}";
  }
 }
 
 static class AgeComparator implements Comparator<MyType> {
  public int compare(MyType e1, MyType e2) {
   return e1.age - e2.age;
  }
 }
 
 public static void main(String[] args) {
  PrioQueue<MyType> pq = new DynArrPrioQueue<>(new AgeComparator());
  pq.insert(new MyType("Daniel", 34));
  pq.insert(new MyType("Anders", 29));
  pq.insert(new MyType("Tora", 32));
  pq.insert(new MyType("Anna", 38));
  pq.insert(new MyType("Sara", 26));
  
  System.out.println(pq.deleteMin());
  System.out.println(pq.deleteMin());
  System.out.println(pq.deleteMin());
  System.out.println(pq.deleteMin());
  System.out.println(pq.deleteMin());
 }
}